#!/usr/bin/env python
import sys

from setuptools import setup, find_packages

with open("tigres/version.py") as f:
    code = compile(f.read(), "tigres/version.py", 'exec')
    exec (code)

install_requires = None
print(install_requires)
print(sys.version_info)
if sys.version_info.major < 3:
    install_requires = ['cloud']
print("Install Requires", install_requires)

setup(name='tigres',
      version=__version__,
      description='Templates Interfaces for Agile Parallel Data-Intensive Science',
      author='Dan Gunter, Lavanya Ramakrishnan, Val Hendrix, Gilberto Pastorello, James Fox, '
             'Gary Kushner, Gonzalo Pedro Rodrigo Alvarez, Ryan Rodriguez',
      author_email='dkgunter@lbl.gov, lramakrishnan@lbl.gov, vchendrix@lbl.gov, gzpastorello@lbl.gov'
                   'foxjas09@gmail.com, gekushner@lbl.gov, gprodrigoalvarez@lbl.gov, ryarodri@uscs.edu',
      url='http://tigres.lbl.gov',
      packages=find_packages(where='./', exclude=['tests', 'resources', 'manifests']),
      package_dir={'tigres': 'tigres'},
      keywords='workflow',
      license='LICENSE.txt',
      include_package_data=True,
      zip_safe=False,
      classifiers=['Development Status :: 3 - Alpha',
                   'Intended Audience :: Science/Research',
                   'Natural Language :: English',
                   'Operating System :: OS Independent',
                   'Programming Language :: Python :: 2.7',
                   'Programming Language :: Python :: 3',
                   'Topic :: Scientific/Engineering',
                   'Topic :: Software Development :: Libraries :: Python Modules'],
      install_requires=install_requires,
      entry_points={
          'console_scripts': [
              'tigres-client = tigres.core.tools.client:main',
              'tigres-log = tigres.core.tools.log:main']})
