#! /usr/bin/env python


import time
import sys
from tigres import *
from tigres.utils import Execution


# Functions

def f_task1(text):
    print("t1: %s, %s" % (text, type(text)))
    print("t1: Sleeping for 5s")

    time.sleep(5)
    print("t1: Waking up after 5s")
    return text + "1, "

def f_task2(text):
    print("t2: %s, %s" % (text, type(text)))
    return text + "2, "

def f_task3(text):
    print("t3: %s, %s" % (text, type(text)))
    return text + "3"

# Workflow

def main(execution):
    # This example tests the parallel_sequential template

    start(name="example_sleeps", log_dest='example_sleeps.log',
          execution=execution)

    outputs = "output"

    task1 = Task("task1", FUNCTION, f_task1, [str])
    task2 = Task("task2", FUNCTION, f_task2, [str])
    task3 = Task("task3", FUNCTION, f_task3, [str])

    tasks = TaskArray("Lane", [task1, task2, task3])

    # first try sequential
    #input_list = [["s-one-{0}".format(x) for x in range(100)]]
    #print input_list
    input = InputArray("S0", [["s-one"]])
    #input = InputArray("S0", input_list)

    print("Running sequence")
    outputs = sequence("sequential", tasks, input)

    if isinstance(outputs, list):
        for output in outputs:
            print("s out: %s" % str(output))
    else:
        print("s out: " + outputs)

    # return
    # next try parallel
    input = InputArray("P0", [["p-one"], ["p-two"], ["p-three"]])

    print("Running parallel")
    outputs = parallel("parallel", tasks, input)

    if isinstance(outputs, list):
        for output in outputs:
            print("p out: %s" % str(output))
    else:
        print("p out: " + outputs)

    # return
    # next try parallel_sequential
    input = InputArray("PS0", [["one"], ["two"], ["three"], ["four"], ["five"], ["six"], ["seven"], ["eight"]])
    # input = InputArray("PS0", [["one"], ["two"]])

    print("Running parallel_sequential")
    outputs = parallel_sequential("parallel_sequential", tasks, input)
 
    if isinstance(outputs, list):
        for output in outputs:
            print("ps out: %s" % str(output))
    else:
        print("ps out: " + str(outputs))

    dot_execution()


if __name__ == "__main__":

    if len(sys.argv) <= 1:
        print(("Usage: {} ({})>".format(sys.argv[0], "|".join(list(Execution.LOOKUP.keys())))))
        exit()

    main(Execution.get(sys.argv[1]))
    end()
