#!/usr/bin/env python
import os
import sys
import random

"""
Shuffles elements in list 
"""
def shuffle(list):
    temp = 0
    for k in range(len(list) - 1, 0, -1):
        randIndex = random.randint(0, k)
        temp = list[k]
        list[k] = list[randIndex]
        list[randIndex] = temp
    return list


"""
Creates a consecutive sequence beginning with "start" and ending with "end" 
"""
def shuffleRange(start, end):
    start, end = int(start), int(end)
    sequence = [k for k in range(start, end + 1)]
    return shuffle(sequence)


"""
Reads array from file, shuffles it, then returns the results back as a string
"""
def shuffleFromFile(filePath):
    with open(filePath, 'r') as file:
        line = file.readline()
    print("read in: " + line)
    intList = []
    for c in line.split(' '):
        intList.append(int(c))
    shuffled = shuffle(intList)
    print("output: " + str(shuffled))

    outStr = ''
    for i in range(len(shuffled) - 1):
        outStr += str(shuffled[i]) + ' '
    outStr += str(shuffled[len(shuffled) - 1])  # manually add in last entry, to avoid tagging on extra space at the end

    return outStr


def main(argv):
    if len(sys.argv) == 2:
        shuffleFromFile(sys.argv[1])
    elif len(sys.argv) == 3:
        print(shuffleRange(sys.argv[1], sys.argv[2]))
    else:
        print("Usage: {} {}, OR {} {} {}".format(sys.argv[0], "file_path", sys.argv[0], "start", "end"))
        sys.exit()


if __name__ == "__main__":
    print("shuffle.py args: " + str(sys.argv))
    main(sys.argv)