import os
import sys


__author__ = 'val'

import unittest


class TestLogCheck(unittest.TestCase):
    def test_log_check_filter_name(self):
        from testfixtures import OutputCapture
        compare_string = """2015-01-20T22:29:48.289337,template_sequence,Sequence_Merge_Background Model,Success
2015-01-20T22:30:03.147407,template_sequence,Sequence_mImgtbl_mAdd,Success"""

        import tigres.core.tools.log as log

        current_directory = os.path.dirname(os.path.abspath(__file__))
        log_file = "{}/test_log_check.log".format(current_directory)

        with OutputCapture() as ocapture:
            log.main(['check', '--template', '--name', 'Sequence', log_file])

        ocapture.compare(compare_string)

    def test_no_name_filter(self):
        from testfixtures import OutputCapture
        compare_string = """2015-01-20T22:29:40.037520,template_sequence,sequence_prepare_get_data,Success
2015-01-20T22:29:47.527755,template_parallel,Parallel mProjectPP,?
2015-01-20T22:29:48.198894,template_parallel,Parallel_mDiffFit,?
2015-01-20T22:29:48.289337,template_sequence,Sequence_Merge_Background Model,Success
2015-01-20T22:29:58.519721,template_parallel,Parallel_mBackground,?
2015-01-20T22:30:03.147407,template_sequence,Sequence_mImgtbl_mAdd,Success"""

        import tigres.core.tools.log as log

        current_directory = os.path.dirname(os.path.abspath(__file__))
        log_file = "{}/test_log_check.log".format(current_directory)

        with OutputCapture() as ocapture:
            log.main(['check', '--template', log_file])

        ocapture.compare(compare_string)

    def test_parse_time_stamp(self):

        time_str ="2015-03-19T13:49:02"
        from tigres.core.monitoring.kvp import parse_timestamp

        assert(parse_timestamp(time_str) == 1426772942)



if __name__ == '__main__':
    unittest.main()
