"""
Description.
"""
import glob
from tigres.core.monitoring import common, end

__author__ = 'Dan Gunter <dkgunter@lbl.gov>'
__date__ = '4/30/13'

import os
import unittest


class BaseTC(unittest.TestCase):
    pass


class TestLogging(BaseTC):
    def setUp(self):
        self._level = os.environ.get(common.ENV_LOG_LEVEL, None)
        if self._level:
            del os.environ[common.ENV_LOG_LEVEL]

    def tearDown(self):
        if self._level:
            os.environ[common.ENV_LOG_LEVEL] = self._level

        end()
        for logfile in glob.glob("tigres*.log"):
            os.unlink(logfile)


    def test_env_level_none(self):
        self.assertEqual(common.env_log_level(), None)

    def test_env_level_set(self):
        for level_name in common.Level.names():
            os.environ[common.ENV_LOG_LEVEL] = level_name
            lvl = common.env_log_level()
            expected = common.Level.to_logging(
                common.Level.to_number(level_name))
            self.assertEqual(lvl, expected)