from tigres.core.utils import SingletonMeta, get_metaclass

__author__ = 'val'

import unittest


class TestShared(unittest.TestCase):
    def test_singleton(self):
        """
        Test the Singleton Metaclass. This should always return the same object.
        """

        class A(get_metaclass(SingletonMeta, 'FOO')):
            def __init__(self):
                print("A.__init__")


        a = A()
        b = A()
        # Check the object ids, They should be the same.
        self.assertEquals(id(a), id(b))


if __name__ == '__main__':
    unittest.main()



